/* -----------------------------------------
   

  dash.js
  part of Arduino Mega Server project
  Dashboard functions
-------------------------------------------- */

var currentPage = '';

// Var's for Processing sketch
var dash_marker1 = 0; // ok XML func
var dash_marker2 = 0; // not ok XML func
var dash_marker3 = 0; // in XML func
var liferFloat = 0.0; // lifer volume
var fig = 2; // type of 3D model

// Device online
var TOTAL_NET_DEVICES = 10;
var netDevicesNames = ["SWH", "HOM", "MED", "CMP", "PRN", "MGA", "UN1", "UN2", "LRN", "APC"];

// Timeline graphics
const MAX_CPU_LOAD_BUFFER = 16;
const MAX_GRAPH_BUFFER = 150;
const MAX_FORM_BUFFER = 90;
var bufferCpuLoad1 = [];
var bufferCpuLoad2 = [];
var bufferCpuLoad3 = [];
var bufferCpuLoad4 = [];
var bufferCpuLoad5 = [];
var bufferCpuLoad6 = [];

var bufferElectro1 = [];
var bufferElectro2 = [];
var bufferElectro3 = [];
var bufferElectro4 = [];
var bufferElectro5 = [];
var bufferElectro6 = [];
var bufferElectro7 = [];
var bufferElectro8 = [];
var bufferElectro9 = [];

var bufferLogo1 = [];

var MAX_MODULES = 16;
var modulName = ["RTC",       "ETR",            "SDC",           "SRV",          "MAJ",         "LRT",           "UPL",          "PIR",        "CNT",            "TMP",        "ELC",                "LED",        "KEY",        "PNG",        "NOO",       "NRF"];
var modulXml  = ["mRtc",      "mEthernet",      "mSd",           "mServer",      "mMajor",      "mLaurent",      "mUpload",      "mPirs",      "mContacts",      "mTemp",      "mElectro",           "mLeds",       "mKeys",     "mPing",      "mNoo",      "mNrf24"];
var modulId   = ["modul-rtc", "modul-ethernet", "modul-sd-card", "modul-server", "modul-major", "modul-laurent", "modul-upload", "modul-pirs", "modul-contacts", "modul-temp", "dash-modul-electro", "modul-leds", "modul-keys", "modul-ping", "modul-noo", "modul-nrf24"];

var contName = ["HOM",        "CLO"];
var contXml  = ["cont1",      "cont2"];
var contId   = ["dash-cont1", "dash-cont2"];

var pirName = ["STD",       "HAL",       "KID",       "KUH",       "PRH",       "CLO"];
var pirXml  = ["pir1",      "pir2",      "pir3",      "pir4",      "pir5",      "pir6"];
var pirId   = ["dash-pir1", "dash-pir2", "dash-pir3", "dash-pir4", "dash-pir5", "dash-pir6"];

var digitalPins = ["D2","D3","D4","D5","D6","D7","D8","D9","D10", "D22","D23","D24","D25","D26","D27", "D30","D31"];
var analogPins  = ["A0","A1","A2","A3","A4","A5","A6","A7","A8","A9","A10","A11","A12","A13","A14","A15","A16"];

var UiId = ["volt", "p1", "p2", "p3", "p4", "p5", "p6", "p7", "p8", "p9", "p10", "p11", "p12", "p13"];
var ui = [];

// Main function
function getDashData() {
  dash_marker2 = parseFloat("1.0");
  dash_marker3 = parseFloat("1.0");

  var request = new XMLHttpRequest();
  request.onreadystatechange = function() {
    if (this.readyState == 4) {
      if (this.status == 200) {
        if (this.responseXML != null) {

          dash_marker1 = parseFloat("1.0");
          dash_marker2 = parseFloat("0.0");

          // Moduls
          for (var i = 0; i < MAX_MODULES; i++) {
            try {
              var modulRes = this.responseXML.getElementsByTagName(modulXml[i])[0].childNodes[0].nodeValue;
            } catch (err) {
                modulRes = "-1";
              }
            try {
              document.getElementById(modulId[i]).innerHTML = modulName[i];
              document.getElementById(modulId[i]).style.background = modulBackground(modulRes);
              document.getElementById(modulId[i]).style.color = modulColor(modulRes);
            } catch (err) { }

            if (i == 13) {var modulPing = modulRes;}
          }

          // Contacts
          for (var i = 0; i < 2; i++) {
            try {
              var dcont = this.responseXML.getElementsByTagName(contXml[i])[0].childNodes[0].nodeValue;
            } catch (err) {
                dcont = "-1";
              }
            try {
              document.getElementById(contId[i]).innerHTML = contName[i];
              document.getElementById(contId[i]).style.background = contactBackground(dcont);
              document.getElementById(contId[i]).style.color = contactColor(dcont);
            } catch (err) { }
          }

          // PIR's
          for (var i = 0; i < 6; i++) {
            try {
              var dpir = this.responseXML.getElementsByTagName(pirXml[i])[0].childNodes[0].nodeValue;
            } catch (err) {
                dpir = "-1";
                //alert('Error' + err.name + ":" + err.message + "\n" + err.stack);
              }

            if (i == 2) {dpir = "-1";}
            try {
              document.getElementById(pirId[i]).innerHTML = pirName[i];
              document.getElementById(pirId[i]).style.background = pirBackground(dpir);
              document.getElementById(pirId[i]).style.color = pirColor(dpir);
            } catch (err) { }
          }

          // Lifer
          var MAX_LIFER = 7;
          var liferStr = '';
          try {
            var lifer = this.responseXML.getElementsByTagName('lifer')[0].childNodes[0].nodeValue;
          } catch (err) {
              lifer = 1;
            }
          liferFloat = parseFloat(lifer);

          for (var i = 0; i < MAX_LIFER; i++) {
            var ch = '·';
            if (i == liferFloat) {ch = '•';}
            liferStr += ch;
          }
          try {
            document.getElementById("lifer").innerHTML = liferStr;
          } catch (err) { }


          // Time & date
          try {
            var time = this.responseXML.getElementsByTagName('time')[0].childNodes[0].nodeValue;
          } catch (err) {
            time = '-'; //поставил своё. НЕ ЗАБЫТЬ!
            }
          try {
            document.getElementById("time").innerHTML = time;
            document.getElementById("time-hide").innerHTML = time;
          } catch (err) { }

          try {
            var day = this.responseXML.getElementsByTagName('day')[0].childNodes[0].nodeValue;
          } catch (err) {
              day = '-';
            }
          try {
            document.getElementById("day").innerHTML = day;
            document.getElementById("day-hide").innerHTML = day;
          } catch (err) {

            }

          try {
            var mon = this.responseXML.getElementsByTagName('month')[0].childNodes[0].nodeValue;
          } catch (err) {
              mon = '-';
            }
          try {
            monthStr = month(mon);
            document.getElementById("month").innerHTML = monthStr;
            document.getElementById("month-hide").innerHTML = monthStr;
          } catch (err) { }

          try {
            var wday = this.responseXML.getElementsByTagName('weekday')[0].childNodes[0].nodeValue;
          } catch (err) {
              wday = '-';
            }
          try {
            weekdayStr = weekday(wday);
            document.getElementById("week-day").innerHTML = weekdayStr;
            document.getElementById("week-day-hide").innerHTML = weekdayStr;
          } catch (err) { }

          // Temperature
          try {
            var tempSTR = this.responseXML.getElementsByTagName('dtempHOME')[0].childNodes[0].nodeValue;
          } catch (err) {
              tempSTR = "-";
            }          
          
          // Voltage & power
          try {
            var dvolt = this.responseXML.getElementsByTagName('voltage')[0].childNodes[0].nodeValue;
          } catch (err) {
              dvolt = "0";
            }
          try {
            var dvoltage = Math.round(parseInt(dvolt), 0);
            /* document.getElementById("dash-voltage").innerHTML = dvoltage;
            document.getElementById("dash-voltage-hide").innerHTML = dvoltage; */
            var tempSTR_ = Math.round(tempSTR, 1);
            document.getElementById("dash-voltage").innerHTML = tempSTR_ + "°";
            document.getElementById("dash-voltage-hide").innerHTML = tempSTR_ + "°";
          } catch (err) { }
		  try {
          var tempHOM = this.responseXML.getElementsByTagName('dhumHOME')[0].childNodes[0].nodeValue;
          } catch (err) {
         tempHOM = "-";
         }

         try {
         var tempHOM_ = Math.round(tempHOM, 1);
         document.getElementById("temp-home").innerHTML = tempHOM_ + "%";
          document.getElementById("temp-home-hide").innerHTML = tempHOM_ + "%";
         } catch (err) { }
		 try {
          var LumHOM = this.responseXML.getElementsByTagName('LumHOME')[0].childNodes[0].nodeValue;
          } catch (err) {
         LumHOM = "-";
         }

         try {
         var LumHOM_ = Math.round(LumHOM, 1);
		 var LumT = "";
		 if (0<LumHOM_ && LumHOM_<=201){
		 LumT = "Светло";}
		 else if (201<LumHOM_&& LumHOM_<=501){
		   LumT = "Приглушенный свет";}
		   else if (501<LumHOM_&& LumHOM_<=801){
		   LumT = "Сумерки";}
		   else if (801<LumHOM_&& LumHOM_<=1027){
		   LumT = "Тьма";}
		   else {umT = "Ошибка";}
         document.getElementById("lum-home").innerHTML = LumT;
          document.getElementById("lum-home-hide").innerHTML = LumT;
         } catch (err) { }

		  
          try {
            var pwr = this.responseXML.getElementsByTagName('power')[0].childNodes[0].nodeValue;
          } catch (err) {
              pwr = "0";
            }
          try {
            var power = Math.round(parseInt(pwr), 0);
            document.getElementById("dash-power").innerHTML = power;
            document.getElementById("dash-power-hide").innerHTML = power;
          } catch (err) { }

          // Uptime
          try {
            var uptm = this.responseXML.getElementsByTagName('uptime')[0].childNodes[0].nodeValue;
          } catch (err) {
              uptm = '-';
            }
          try {
            document.getElementById("dash-uptime").innerHTML = uptm;
          } catch (err) { }

          // free RAM
          try {
            var freeRam = this.responseXML.getElementsByTagName('freeRAM')[0].childNodes[0].nodeValue;
          } catch (err) {
              freeRam = '-';
            }
          try {
            var freeRamPer = Math.round(freeRam / 80, 0);
            document.getElementById("dash-free-ram").innerHTML = freeRam + ' / ' + freeRamPer + '%';
          } catch (err) { }

          // Cyclos / CPU load
          try {
            var cyclosDelay = this.responseXML.getElementsByTagName('cycDelay')[0].childNodes[0].nodeValue;
          } catch (err) {
              cyclosDelay = '-';
            }
          try {
            var cyclosInSec = this.responseXML.getElementsByTagName('cycInSec')[0].childNodes[0].nodeValue;
          } catch (err) {
              cyclosInSec = '-';
            }

          try {
            load('cpu-load',  1, freeRamPer, '', bufferCpuLoad1, '', 'mem', 'rgba(100, 160, 230, 1)', 'yellow', 'cyan');
          } catch (err) { }
          
          insertTick(16, bufferCpuLoad3);
          
          //try {
          //  load('cpu-load2', 2, cyclosDelay, cyclosInSec, bufferCpuLoad2, bufferCpuLoad3, 'cpu', 'rgba(100, 160, 230, 1)', 'yellow', 'cyan');
          //} catch (err) { }
          
          try {
            load('cpu-load3', 3, cyclosDelay, '', bufferCpuLoad4, '', 'cpu', 'rgba(100, 160, 230, 1)', 'cyan', 'lightblue');
          } catch (err) { }
          try {
            load('cpu-load4', 4, cyclosDelay, cyclosInSec, bufferCpuLoad5, bufferCpuLoad6, 'cpu', 'rgba(100, 160, 230, 1)', 'yellow', 'cyan');
          } catch (err) { }

          // Mode
          try {
            var mode = this.responseXML.getElementsByTagName('mode')[0].childNodes[0].nodeValue;
          } catch (err) {
              mode = "-";
            }
          if (mode == 1) {
            modeText = 'ONE';
          } else {
              modeText = 'MDM';
            }
          try {
            document.getElementById('mode').innerHTML = modeText;
            document.getElementById('mode').style.background = modeBackground(mode);
            document.getElementById('mode').style.color = modeColor(mode);
          } catch (err) { }

          // Force
          try {
            var force = this.responseXML.getElementsByTagName('force')[0].childNodes[0].nodeValue;
          } catch (err) {
              force = "-";
            }
          if (force == 1) {
            forceText = 'FRC';
          } else {
              forceText = 'NRM';
            }
          try {
            document.getElementById('force').innerHTML = forceText;
            document.getElementById('force').style.background = forceBackground(force);
            document.getElementById('force').style.color = forceColor(force);
          } catch (err) { }          
          
          // Time provider
          try {
            var timeProv = this.responseXML.getElementsByTagName('timeProv')[0].childNodes[0].nodeValue;
          } catch (err) {
              timeProv = "-";
            }
          switch (timeProv) {
            case "0":
              timeProvText = 'NON';
              break;
            case "1":
              timeProvText = 'NET';
              break;
            default:
              timeProvText = 'RTC';
            break;
          }
          try {
            document.getElementById('time-sync').innerHTML = timeProvText;
            document.getElementById('time-sync').style.background = timeProviderBackground(timeProv);
            document.getElementById('time-sync').style.color = timeProviderColor(timeProv);
          } catch (err) { }
          
          // Auth
          try {
            var auth = this.responseXML.getElementsByTagName('auth')[0].childNodes[0].nodeValue;
          } catch (err) {
              auth = "-";
            }
          var authText = '';
          if (auth == 1) {
            authText = 'AUT';
          } else {
              authText = 'FRE';
            }
          try {
            document.getElementById('auth').innerHTML = authText;
            document.getElementById('auth').style.background = authBackground(auth);
            document.getElementById('auth').style.color = authColor(auth);     
          } catch (err) { }
          try {
            document.getElementById('auth-footer').innerHTML = authText;
            document.getElementById('auth-footer').style.background = authBackground(auth);
            document.getElementById('auth-footer').style.color = authColor(auth);            
          } catch (err) { }
          
          // Ports page
          if (currentPage == 'ports-page') {
            // digital pins
            for (var i = 0; i < digitalPins.length; i++) {
              try {
                var pinState = this.responseXML.getElementsByTagName(digitalPins[i])[0].childNodes[0].nodeValue;
              } catch (err) {
                  pinState = "-1";
                }
              try {
                document.getElementById(digitalPins[i]).innerHTML        = stateOnOff(pinState);
                document.getElementById(digitalPins[i]).style.background = stateOnOffBackground(pinState);
                document.getElementById(digitalPins[i]).style.color      = stateOnOffColor(pinState);
              } catch (err) { }
            }
            // analog pins
            for (var i = 0; i < analogPins.length; i++) {
              try {
                var aPinState = this.responseXML.getElementsByTagName(analogPins[i])[0].childNodes[0].nodeValue;
              } catch (err) {
                  aPinState = "-1";
                }
              try {
                document.getElementById(analogPins[i]).innerHTML = aPinState;
              } catch (err) { }
            }
          } // ports-page

          // Supply page works
          if (currentPage == 'supply-page') {
            // Electro
            try {
              document.getElementById("volt").innerHTML = dvoltage;
            } catch (err) { }
            try {
              document.getElementById("p1").innerHTML = power;
            } catch (err) { }

            try {
              graph('graph-voltage', 3, dvoltage, '', bufferElectro9, '', 'pwr', 'rgba(4, 169, 174, 1)', 'rgba(204,9,51, 1)', 'lightblue');
            } catch (err) { }
            try {
              graph('graph-power', 3, power, '', bufferElectro1, '', 'pwr', 'rgba(4, 169, 174, 1)', 'rgba(213,125,12, 1)', 'lightblue');
            } catch (err) { }

            // Period
            try {
              var period = this.responseXML.getElementsByTagName('period')[0].childNodes[0].nodeValue;
              period -= 100;
            } catch (err) {
                period = "-";
              }
            try {
              var frec = 1 / (period / 1000000);
              document.getElementById("freq").innerHTML = frec.toFixed(2);
            } catch (err) { }

            try {
              graph('graph-freq', 3, frec.toFixed(2), '', bufferElectro7, '', 'pwr', 'rgba(4, 169, 174, 1)', 'rgba(44,77,220, 1)', 'lightblue');
            } catch (err) { }
          } // if (currentPage == 'supply-page')

          // Electro page works
          if (currentPage == 'electro-page') {

            // Electro modul
            try {
              var modulElectro = this.responseXML.getElementsByTagName('modulElectro')[0].childNodes[0].nodeValue;
            } catch (err) {
                modulElectro = '-';
              }

            var modulElectroStatus = "";

            switch (modulElectro) {
              case "0":
                modulElectroStatus = "выключен";
                break;
              case "1":
                modulElectroStatus = "включен";
                break;
              default:
                modulElectroStatus = "отсутствует";
                try {
                  document.getElementById("button-electro").innerHTML = "-";
                  document.getElementById("button-electro").style.background = modulDisable;
                } catch (err) { }
              break;
            }
            try {
              document.getElementById("modul-electro").innerHTML = modulElectroStatus;
            } catch (err) { }

            // Electro
            for (var i = 0; i < 14; i++) {
              try {
                ui[i] = this.responseXML.getElementsByTagName(UiId[i])[0].childNodes[0].nodeValue;
                ui[i] = Math.round(parseInt(ui[i]), 0);
              } catch (err) {
                  ui[i] = "...";
                }
              try {
                document.getElementById(UiId[i]).innerHTML = ui[i];
              } catch (err) { }

            }
            try {
              graph('graph-test', 3, ui[1], '', bufferElectro1, '', 2, 'rgba(4, 169, 174, 1)', 'rgba(204,9,51, 1)', 'lightblue');
            } catch (err) { }
            try {
              graph('graph-cond', 3, ui[4], '', bufferElectro2, '', 2, 'rgba(4, 169, 174, 1)', 'rgba(213,125,12, 1)', 'lightblue');
            } catch (err) { }
            try {
              graph('graph-plita', 3, ui[2], '', bufferElectro3, '', 2, 'rgba(4, 169, 174, 1)', 'rgba(166,0,151, 1)', 'lightblue');
            } catch (err) { }
            try {
              graph('graph-str', 3, ui[3], '', bufferElectro4, '', 2, 'rgba(4, 169, 174, 1)', 'rgba(75,152,190, 1)', 'lightblue');
            } catch (err) { }
            try {
              device('device-plita', 3, ui[2], 'Плита',             200, 500, 900, 1500);
            } catch (err) { }
            try {
              device('device-str',   3, ui[3], 'Стиральная машина', 60, 300, 1500, 2000);
            } catch (err) { }
            try {
              device('device-cond',  3, ui[4], 'Кондиционер',       60, 100, 600, 1500);
            } catch (err) { }

            // draw bar
            //drawBar(p2, p3, p4, p6, p7, p8, p9, p10, p11, p12, p13);
          } // if (currentPage == 'electro-page')


          // Online net devices
          for (var i = 0; i < TOTAL_NET_DEVICES; i++) {
            var j = i + 1;
            var tagOnline = "dash-online" + j;
            if (modulPing == 0 || modulPing == 1) {
              try {
                var dOnline = this.responseXML.getElementsByTagName(netDevicesNames[i])[0].childNodes[0].nodeValue;
              } catch (err) {
                  dOnline = "-1";
                }
              try {
                document.getElementById(tagOnline).innerHTML = netDevicesNames[i];
                document.getElementById(tagOnline).style.background = onlineBackground(dOnline);
                document.getElementById(tagOnline).style.color = onlineColor(dOnline);
              } catch (err) { }
            } else {
                try {
                  document.getElementById(tagOnline).style.display = "none";
                } catch (err) { }
              }
          } // for (var i = 0; i < TOTAL_NET_DEVICES; i++)

        } // if (this.responseXML != null)
      } // if (this.status == 200)
    } // if (this.readyState == 4)
  } // request.onreadystatechange = function()

  dash_marker1 = parseFloat("0.0");

  // send HTTP GET request with LEDs to switch on/off if any
  request.open("GET", "request_dash" + currentPage + randomNoCache(), true);
  request.send(null);
  setTimeout('getDashData()', 2000);
  dash_marker3 = parseFloat("0.0");
} // getDashData()

/* end */
